#ifndef GL_LIGHT_INCLUDE
#define GL_LIGHT_INCLUDE

#include <map>
#include "vector.h"
#include "rgba.h"



namespace ist {
namespace gl {


class Light
{
public:
	vector4 position;
	fRGBA ambient, diffuse, specular;

	Light();
	~Light();

	void enable();
	void disable();
	bool isValid() { return id!=0; }

private:
	static std::map<int, Light*> light_list;

	int id;
};


} //gl
} //ist

#endif
