#include "gl_include.h"
#include "gl_matrix_saver.h"

namespace ist {
namespace gl {


MatrixSaver::MatrixSaver(int matrix_type) {
	glGetFloatv(matrix_type, matrix.v);

	switch(matrix_type) {
	case GL_MODELVIEW_MATRIX:
		matrix_mode=GL_MODELVIEW;
		break;
	case GL_PROJECTION_MATRIX:
		matrix_mode=GL_PROJECTION;
		break;
	case GL_TEXTURE_MATRIX:
		matrix_mode=GL_TEXTURE;
		break;
	default:
		matrix_mode=GL_MODELVIEW;
		break;
	}
}

MatrixSaver::~MatrixSaver() {
	int current_matrix_mode;
	glGetIntegerv(GL_MATRIX_MODE, &current_matrix_mode);

	glMatrixMode(matrix_mode);
	glLoadMatrixf(matrix.v);
	glMatrixMode(current_matrix_mode);
}


} //gl
} //ist

