#ifndef _SINGLETON_INCLUDE_
#define _SINGLETON_INCLUDE_


namespace ist {


template<class T>
class Singleton {
public:
	static T* instance()
	{
		if(_instance==0)
			_instance=new T;

		return _instance;
	}

protected:
	static T *_instance;
	Singleton() {}
	Singleton(const Singleton&);
	Singleton& operator =(const Singleton&);

	virtual ~Singleton() {
		if(_instance!=0)
			delete _instance;
	}
};


template<class T>
T* Singleton<T>::_instance=0;



}

#endif
