#include <stdlib.h>
#include "static_font.h"

static const char font_data[]={
#include "font.res"
};

int font_data_size=sizeof(font_data);
static int font_data_read_pos=0;

static int static_read(void *data, int length)
{
	if(font_data_read_pos > font_data_size)
		return 0;

	memcpy(data, font_data+font_data_read_pos, length);

	font_data_read_pos+=length;
	return length;
}


StaticFont::StaticFont()
{
	font_size=0;
	char_byte=0;

	static_read(&font_size, sizeof(int));

	int n=0;
	while(n<font_size) { n+=8; }
	int char_bit=n*font_size;
	char_byte=char_bit/8;


	unsigned char length, temp;
	while(static_read(&length, 1)) {
		if(length<0x80) {
			for(int i=0; i<length+1; ++i) {
				static_read(&temp, 1);
				data.push_back(temp);
			}
		}
		else {
			static_read(&temp, 1);

			for(int i=0x80; i<length+1; ++i)
				data.push_back(temp);
		}
	}
	font_data_read_pos=0;

	max_index=data.size()/char_byte;
}

