#include <string>
#include "ist_lua.h"
#include "spline.h"



class Timeline1 : public ist::Spline2D
{
public:
	typedef ist::Spline2D::iterator iterator;

	Timeline1(float r=2.0f);
	void sampling();
	float getValue(float x);

	void erase(iterator itr);
	void insert(const ist::vector2& p);
	void insert(const ist::vector2& i, const ist::vector2& p, const ist::vector2& o);

	std::vector<ist::vector2> s_points;

private:
	float rate;
};


class Timeline3
{
public:
	Timeline3(float r=2.0f);
	void sampling();
	ist::vector3 getValue(float t);

	Timeline1 x;
	Timeline1 y;
	Timeline1 z;
};


namespace timeline {
	void regist_timeline_functions(lua_State *L);
	void add_timeline1(const std::string& name, Timeline1 *tl);
	void add_timeline3(const std::string& name, Timeline3 *tl);
}
